﻿:Namespace ⍙⍙

    Version←1.11

    (⎕IO ⎕ML ⎕CT)←1 2 1E¯13
    C←⎕av[⎕io+3]
    APLsCovered←'APL2PC APLX APLC' 'APL2MF' 'DYALOG' 'APLPLUS' 'VSAPL' 'STSCMF'

    _←⍬
    _,←⊂'This workspace is used for transferring simple objects to/from ATF files.'
    _,←⊂'Version ',2⍕Version
    _,←⊂''
    _,←⊂'To use it do'
    _,←⊂'  ⍙⍙.ATFIN ''filepath[.atf] -fliplu -APL=aaa''  '
    _,←⊂''
    _,←⊂'where APL can be any of the strings found in ⍙⍙.APLsCovered.'
    _,←⊂'If -fliplu is supplied the lowercase and underscored alphabets are'
    _,←⊂'reversed.'
    _,←⊂''
    _,←⊂'The global variable PROBLEMS is used to capture objects that cannot'
    _,←⊂'be handled.'
    _,←⊂''
    _,←⊂'The global char vector ⍙⍙.Translate contains the map from the source'
    _,←⊂'⎕AV to DYALOG''s ⎕AV.  ⎕AV[N] in the source APL becomes ⎕AV[⍙⍙.Translate[N]]'
    _,←⊂'in DYALOG. This table is slightly different for APL2MF.'
    _,←⊂'If no -APL is supplied the program will attempt to guess the source'
    _,←⊂'APL but there is no guaranty this will work.'
    _,←⊂''
    _,←⊂'To send a ws to file use'
    _,←⊂'   ⍙⍙.ATFOUT ''filepath[.atf] -objects=...'''
    _,←⊂''
    _,←⊂'If you have any problems with this code, then please'
    _,←⊂'direct your enquiries to whoever supplied your copy of Dyalog APL.'
    DESCRIBE←{⎕ml←0⋄↑⍵}_

    _ ←   0   8  10  13  32   1   2   3   4   9 159   5  37  39 224 249  95  97  98  99 100 101 102 103 104 105 106 107 108 109 110 111
    _,← 112 113 114 115 116 117 118 119 120 121 122   6   7 253  46  11  48  49  50  51  52  53  54  55  56  57  12 214  15  36 156  16
    _,← 182  65  66  67  68  69  70  71  72  73  74  75  76  77  78  79  80  81  82  83  84  85  86  87  88  89  90  17  18  19  20  21
    _,← 247  22  23  24 128  25  26  27 141  28  29  30  31 127 158 166 167 170 171 219 176 177 178 222 185 149 186 123  14 125 215 211
    _,← 254 187 142 143 188 200 201 165 153 202 154 225 133 160 131 132 134 204 135 138 130 136 137 161 140 139 164  91  47 240  92 241
    _,←  60 243  61 242  62 244 235  94  45  43 246 245  63 238 230 126 198 199 236 234  42 169 190 183 248  40 226 227 239 172 157 152
    _,← 124  59  44 231 229 252 251 237 232 233 181 146  33 174 175 250 205 207 206 162 147 148 155  34  35 208  38 210 217 191 218 192
    _,← 197 196 195 180 193 194 179  64 151 163 150 212 129  96 221 213  58 209 168 173 216 189 184 228  41  93 220 223 203 144 145 255
    Translate←_

    ⎕ex¨ 'C_'

    ∇ {Target}ATFIN arg;Filename;POS;TXT;NM;DUFF;Filenum;Block;SCRIPT;⎕ML;more;TR;t;Pa;sc;len
     ⍝ Transfer in from an ATF file produced by e.g. )OUT on IBM
     ⍝ All system variables are saved at the end.
     ⍝ All system variable changes saved in QuadThings
     ⍝ Anything that won't fix is saved in PROBLEMS
     ⍝
      ⎕IO←1 ⋄ ⎕ML←1                               ⍝ DO NOT CHANGE ⎕IO!
      t←1↓t,ToLower t←∊' ',¨APLsCovered
      Pa←(⎕NEW ⎕SE.Parser,⊂('-fliplu -apl=',t)'upper').Parse arg
      Filename←(1⊃Pa.Arguments){⍺,(~'.'∊⍺)/⍵}'.atf'⍝ append extension if none there
      '... Processing file ',Filename
     
     ⍝ We try to determine the width of the 'records' - should be a multiple of 80 to 84
      (Filenum t)←Pa OPEN Filename
      Block←(0,t)⍴''
      SCRIPT←0 72⍴PROBLEMS←QuadThings←''
      :If 0=⎕NC'Target' ⋄ Target←# ⋄ :EndIf
      CTarget←(⍕Target),'.'                       ⍝ where do we have to define these objects
      'Cannot define objects in this namespace'⎕SIGNAL 11 if Target≡⎕THIS
      ⎕WSID←{((0∊b)×-1+⊥⍨b←'.'≠⍵)↓⍵}Filename      ⍝ change ws here to avoid overwriting the original
      more←1
     
      :While more
          :If (POS←⌊/SCRIPT[;1]⍳'Xx')≤⊃⍴SCRIPT    ⍝ Got some to be getting on with
              TXT←,0 1↓SCRIPT[⍳POS;]              ⍝ Extract block of text (drop X column)
              SCRIPT←(POS,0)↓SCRIPT               ⍝ And throw away from script
              :Select ⍬⍴TXT                       ⍝ What are we dealing with?
              :CaseList 'ACNacn'   ⍝ Variable
                  :If '⎕'=TXT[2]                  ⍝ If it is a system object
                      QuadThings,←⊂TXT            ⍝ then save it until later
                  :Else
                      CHARFN TXT
                  :EndIf
              :CaseList 'fF'                      ⍝ Function; it may use ⎕FX or not
                  ⎕←'Function  : ',NM←1↓(t←TXT⍳' ')↑TXT ⍝ What's its name?
                  :If '⎕'∊21↑TXT←CORRECT TXT
                      t←¯1+TXT⍳'⎕'                    ⍝ where does ⎕FX start
                      TXT←t↓TXT                       ⍝ Throw away any left arg of ⎕FX
                      :If ⍱/0 2∊10|⎕DR⍎CTarget,TXT    ⍝ Execute it - check for error
                          '*** Cannot fix : ',NM      ⍝ Tell user about the problem
                          PROBLEMS,←⊂TXT              ⍝ and save copy of text
                      :EndIf
                  :Else ⍝ is RANK, SHAPE, CODE
                      len←55⌊⍴TXT←(1+⍴NM)↓TXT
                      sc←⍴t←(∧\TXT[⍳len]∊' ',⎕D)/len↑TXT  ⍝ separate Rank/Shape from code
                      t←2⊃⎕VFI t
                      :If t[1]≠¯1+⍴t
                      :OrIf ⍱/0 2∊10|⎕DR Target.⎕FX(1↓t)⍴sc↓TXT,'    '
                          ⎕←'*** Cannot fix : ',NM
                          PROBLEMS,←⊂TXT              ⍝ and save copy of text
                      :EndIf
                  :EndIf
              :Else
                  -⎕←'Invalid TYPE or format in file'
              :EndSelect
     
          :Else
             ⍝ We don't have a block. Try to get next block from file. If sucessful continue
             ⍝ processing, otherwise stop as we have reached end of file. Ignore * lines.
              more←~0∊⍴SCRIPT⍪←{(⍵[;1]≠'*')⌿⍵}(GETNEXTBLOCK 500)[;⍳72]
          :EndIf
      :EndWhile                                   ⍝ Repeat for next block
     
      ⎕NUNTIE Filenum
     
      CHARFN¨Target.QuadThings←QuadThings
      ⎕←'... Finished'
      ⎕←'   ↑QuadThings ⍝  to see the systems variables modified'
      :If '*'∊4⍴⎕STACK
          ⎕←'To remove the ws'' transfer objects, execute the following line'
          ⎕←'   ⎕EX ''⍙⍙'' ⍝ and do'
      :EndIf
      ⎕←'   )save ',Filename
      →(0∊⍴PROBLEMS)↑0
      ⎕←'*** PROBLEMS contains unfixed objects'
      Target.PROBLEMS←PROBLEMS
    ∇

    ∇ code←CORRECT code;by;c
      :For c by :In 'Ó←' 'Ú→' 'Ã↑' 'È↓' 'Í⌊' 'Ð∇'
          ((code=c)/code)←by
      :EndFor
    ∇

    ∇ CHARFN TXT;⎕TRAP;RANK;SHAPE;DATA;i;n;TYPE;NM
     ⍝ TXT is the transfer file string that represents one variable.
     ⍝ This function creates the variable in the workspace.
      →0 if' '∧.=TXT ⍝ cover null case
      :Trap 0
          i←{⎕IO←1 ⋄ ⍺⍳⍵} ⍝ because we can't trust ⎕IO to be 1
          'Variable : ',NM←1↓¯1↓((TXT∊'← ')i 1)↑TXT  ⍝ Whats its name?
          :If 'Aa'∊⍨TYPE←1↑TXT
              ⍎CTarget,1↓TXT
          :Else
              DATA←(TXT i' ')↓TXT
              SHAPE←⍴RANK←⍎(DATA⍳' ')↑DATA
              DATA←(DATA i' ')↓DATA
              :If 0<RANK
                  n←RANK i⍨+\' '=DATA
                  SHAPE←'⍴',⍨n↑DATA
                  DATA←n↓DATA
              :EndIf
              ⍎CTarget,NM,'←',SHAPE,('NncC'⍳TYPE)⊃2/(DATA,',⍬')'DATA'
          :EndIf
      :Else
          'Cannot form variable ',NM
          PROBLEMS,←⊂('(',1↑TXT),') ',1↓TXT
      :EndTrap
    ∇

    ∇ BLOCK←GETNEXTBLOCK LINES;⎕IO;LCOUNT;BL;colw
     ⍝ For translating from .ATF files (e.g. produced by APL2 ')OUT')
     ⍝ into Dyalog APL (ASCII)
     ⍝ BLOCK will always have 80-83 columns and 0+ rows, unless the end
     ⍝ of the input file has been reached (then 0 rows).
     ⍝ Block, TR, Filenum are global.
     ⍝
      ⎕IO←0
      colw←1↓⍴Block                  ⍝ Block acts as a buffer
      :If LINES>1↑⍴Block             ⍝ has Block enough lines to meet request?
          BL←⎕NREAD Filenum,82,LINES×colw
          BL←((⌊(⍴BL)÷colw),colw)⍴BL ⍝ and reshape to lines of 80 to 83
          Block⍪←BL                  ⍝ buffer it
      :EndIf                         ⍝ Return what is asked for if possible
      BLOCK←((LCOUNT←LINES⌊1↑⍴Block),colw)↑Block
      Block←(LCOUNT,0)↓Block
    ∇

    ∇ (Filenum BS)←Pa OPEN File;⎕TRAP;EM;sz;t;TR
      'File <',File,'> has length ',⍕sz←⎕NSIZE Filenum←File ⎕NTIE 0
      :If 0∊⍴t←{(0=s|⍵)/s←79+⍳5}sz
          ⎕←'Unable to determine block size, trying with ',⍕BS←80
      :Else ⍝ if more than 1 favor 82 then 80
          :If 1≠⍴t ⋄ ⎕←'Ambiguous block size; picking',t←1↑t[⍒2 1+.×82 80∘.=t] ⋄ :EndIf
          BS←t
      :EndIf
      TR←Pa SetTR Filenum,BS               ⍝ Set up translation
      TR ⎕NXLATE Filenum
    ∇

    ∇ tr←la SetTR(fn bs);apl;i;⎕IO;n
     ⍝ Find translation to apply from looking at the file if no APL specified.
      ⎕IO←0
      :If 0≡la.APL
        ⍝ Find signature: read 1st few 100 bytes
          {}⎕NREAD fn 83 0 0 ⍝ ensure at start
          n←⍴i←⎕NREAD fn 83,2↑1+bs×21
          :Select {(>/⍵)⌽⍵}∪i[bs×⍳⌈n÷bs]~42 92 180 ⍝ remove *s
          :CaseList (⊂i),,¨i←32 88 ⋄ apl←'APL2PC'
          :CaseList (⊂i),,¨i←¯25 64 ⋄ apl←'APL2MF'
          :CaseList (⊂i),,¨i←4 88 ⋄ apl←'DYALOG'
          :Else ⋄ 'unknown APL'⎕SIGNAL 11
          :EndSelect
        ⍝ Reset file read pointer to beginning
          {}⎕NREAD fn 83 0 0
      :Else ⍝ ensure uppercase
          apl←ToUpper la.APL
      :EndIf
      tr←Translate
      :If apl≡'APL2MF'
     ⍝ There should be a special table for APL2MF here but fn <CORRECT> does the trick instead
      :EndIf
     ⍝ Reverse underscored letters and lowercase letters?
      :If la.FLIPLU=apl≡'APL2PC' ⍝ 'flip' reversed for this APL
          i←⎕AV⍳LC,⎕A
          tr[i]←26⌽tr[i]
      :EndIf
    ∇

    LC←'abcdefghijklmnopqrstuvwxyz'
    ToLower←{⎕IO←0 ⋄ b←26>i←⎕A⍳s←,⍵ ⋄ (b/s)←LC[b/i] ⋄ s}

    ToUpper←{⎕IO←0 ⋄ b←26>i←LC⍳s←,⍵ ⋄ (b/s)←⎕A[b/i] ⋄ s}

    if←/⍨ 
    
    ∇ testws;valid;allfns;dubious;chk
    ⍝ This fn verifies that no character has been missed when importing
    ⍝ code. To do so it screens out all the characters it knows are valid.
      valid←⊂LC,' ;:@#,.-[]{}/⋄!"£$%^&*()_+¨¯<≤=≥>≠∨∧×÷≡⍫⍒⍋⌽⍉⊖⍟⍱⍲⌹?⍵∊⍴~↑↓⍳○*←→↑↓⌶⍣⍞⍬⍺⌈⌊_∇∆∘''⎕⍎⍕⍺⌈⌷≡⍪≢⊢⊂⊥⊤|⍝⍀⌿⊣⊃∩∪⍷⍙⍨',⎕A,⎕D
      :If 0∊⍴allfns←⎕RSI[⎕IO].⎕NL-3 4
      :OrIf ∧/~chk←0≠∊⍴¨dubious←valid(⎕RSI[⎕IO]).{∪(,⎕CR ⍵)~⍺}¨allfns
          ⎕←'Nothing to report'
      :Else
          ⎕←'These functions have dubious characters:'
          ⎕←chk⌿allfns,[1.1]dubious
      :EndIf
    ∇

 ⍝   =====================      OUT code     =====================

    ∇ {source}ATFOUT arg;OBJS;obj;fn;class;state;⎕IO;⎕ML;val;n;X;Pa
⍝ arg is a string of filename possibly followed by -objects=...
⍝ If omitted, all objects are re-constituted.
⍝
      ⎕ML←⎕IO←1
      Pa←(⎕NEW ⎕SE.Parser,⊂'-objects= -external' 'upper').Parse arg
      fn←OUTINIT 1⊃Pa.Arguments
⍝ If no names explicitly chosen, transfer everything in WS except if -external is specified in which
⍝ case ⎕fns specific  to Dyalog are skipped.
⍝ We need to find where the objects are to start with. We cannot assume this ns was copied in a ws and used
⍝ from there, it could be called from Spice way down the stack in some unknown ns.
      :If 0=⎕NC'source' ⋄ source←⍎(⍴⎕NSI)⊃⎕NSI ⋄ :EndIf
      :If 0≡OBJS←Pa.OBJECTS
          OBJS←(3×Pa.EXTERNAL)↓'⎕RTL' '⎕DIV' '⎕TRAP' '⎕CT' '⎕IO' '⎕LX' '⎕PP' '⎕PW' '⎕RL'
          OBJS,←source.⎕NL-2 3 4 ⍝ no namespaces transferred to other systems
      :Else
          OBJS←{(1↓¨(⍵∊' ')⊂⍵)~⊂''}' ',OBJS
          'Invalid object (vars & fns only)'⎕SIGNAL 11 if~∧/(⌊source.⎕NC OBJS)∊2 3 4
      :EndIf
     
      :For obj class :InEach OBJS(source.⎕NC¨OBJS)
⍝ Find the basic representation to recreate a variable
          :If class=¯1 ⍝ ⎕var
              :If 1∊1⊃state←⎕STATE obj ⍝ shadowed?
                  val←⊃⌽4⊃state
              :Else
                  val←⍎obj
              :EndIf
              val←'A',obj,'←',⎕SE.Dyalog.Utils.repObj val
          :ElseIf class=2 ⍝ var
              val←'A',obj,'←',⎕SE.Dyalog.Utils.repObj source⍎obj
          :Else ⍝ must be a fn/op
              val←'F',obj,' ⎕fx ',⎕SE.Dyalog.Utils.repObj source.⎕NR obj
          :EndIf
⍝ Append representation in antiquated 80 column card format a la IBM
          X←'X'↑⍨-n←⌈(⍬⍴⍴val)÷71 ⋄ val←(X,n 79↑n 71⍴(n×71)↑val),n 2⍴⎕AV[4 3]
          val ⎕NAPPEND fn,82
      :EndFor
     
      ⎕←'Job completed. File size=',⍕⎕NSIZE fn
      ⎕NUNTIE fn
    ∇

    ∇ num←OUTINIT Filename
⍝ Create/rewrite file
      Filename←(-⊥⍨' '=Filename)↓Filename
      Filename←Filename{⍺,(⍵≢(-⍴⍵)↑⍺)/⍵}'.atf'
      :Trap 22
          num←Filename ⎕NCREATE 0
      :Else
          :Trap 0
              Filename ⎕NERASE Filename ⎕NTIE 0
              num←Filename ⎕NCREATE 0
          :Else
              'Cannot create file ',Filename,' :',⎕EM ⎕EN
              →
          :EndTrap
      :EndTrap
      Translate ⎕NXLATE num
    ∇

:EndNamespace